#include <ShObjIdl.h>
#include <Shlwapi.h>

void SetProcessAppID();
int shellSupportsAppID();
int getDLLVersion(HINSTANCE hinstDll, DWORD *majorVersion, DWORD *minorVersion);

typedef HRESULT (__stdcall *SETAPPIDPROC)(PCWSTR);

/*
 * Called from WinMain to set a process-wide Application User Model ID.
 * Does a GetProcAddress on Shell32 so as not to make the dynamic linker give up when we're not on
 * Shell32.dll version 6.1 or newer when invoking SetCurrentProcessExplicitAppUserModelID.
 */
void SetProcessAppID()
{
	HINSTANCE hShell32;
	hShell32 = LoadLibrary(TEXT("Shell32.dll"));

	if (hShell32)
	{
		if (shellSupportsAppID(hShell32))
		{
			SETAPPIDPROC SetAppID;
			SetAppID = (SETAPPIDPROC)GetProcAddress(hShell32, "SetCurrentProcessExplicitAppUserModelID");
			(*SetAppID)(L"net.taricorp.PuttyJL");
		}

		FreeLibrary(hShell32);
	}
}

/*
 * Checks whether we're on a version of Windows supporting jump lists, etc by
 * checking the version exported by Shell32.dll
 */
int shellSupportsAppID(HINSTANCE shell32)
{
	DWORD major,minor;
	if (getDLLVersion(shell32, &major, &minor))
	{
		//From MSDN: Windows 7 has version 6.1 of Shell32
		if (major >= 6 && minor >= 1)
			return 1;
	}
	return 0;
}

int getDLLVersion(HINSTANCE hinstDll, DWORD *majorVersion, DWORD *minorVersion)
{
	//Get handle for DllGetVersion
	DLLGETVERSIONPROC dllGetVersion;
	DLLVERSIONINFO dvi;
	HRESULT hr;

	hr = E_FAIL;
	dllGetVersion = (DLLGETVERSIONPROC)GetProcAddress(hinstDll,"DllGetVersion");

	//Verify function is exported
	if (dllGetVersion)
	{
		ZeroMemory(&dvi,sizeof(dvi));
		dvi.cbSize = sizeof(dvi);
		//Invoke
		hr = (*dllGetVersion)(&dvi);
	}
	if (SUCCEEDED(hr))
	{
		*majorVersion = dvi.dwMajorVersion;
		*minorVersion = dvi.dwMinorVersion;
		return 1;
	}
	return 0;
}